<?php
/*

This sample PHP-script is provided AS IS and you should use it at your own risk.

  $Id: hoopay.php,v 1.0 2009/21/08

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2009 osCommerce

  Released under the GNU General Public License
  http://www.opensource.org/licenses/gpl-license.html

  HooPay Asset Management S.A.
  http://www.hoopay.com

  Copyright (c) 2009 HooPay.com

*/
  class hoopay{
    var $code, $title, $description, $enabled;

// class constructor
    function hoopay() {
      global $order;

      $this->code = 'hoopay';
      $this->title = MODULE_PAYMENT_HOOPAY_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_HOOPAY_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_HOOPAY_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_HOOPAY_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_HOOPAY_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_HOOPAY_ORDER_STATUS_ID;
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
	$img_hoopay = 'images/payment/hoopay/logo.gif';
	$hp_explain = MODULE_PAYMENT_HOOPAY_CC_EXPLAIN;
	$hp_txt = sprintf(MODULE_PAYMENT_HOOPAY_CC_TEXT,
			    		tep_image($img_hoopay,' Hoopay ','','','align=ABSMIDDLE')
			    		);
	$fields[] = array('title' => '', //MODULE_PAYMENT_HOOPAY_TEXT_TITLE,
			    'field' => '<div><b>' . $hp_txt . '</b></div>' . $hp_explain);
	return array('id' => $this->code,
		     	'module' => $this->title,
		     	'fields' => $fields);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      $title = $this->title;
      $confirmation = array('title' => MODULE_PAYMENT_HOOPAY_TEXT_PAY_INFO);
      return $confirmation;
    }

    function process_button() {
       return false;
    }

    function before_process() {
      	return false;
    }

    function after_process() {
      global $order, $currencies, $currency, $cart, $insert_id;
    	// Store correct total amount for the currency chosen in variable
    	$hpOrderTotalV = ($order->info['total'] - $order->info['shipping_cost']) * $currencies->get_value($currency);
    	$hpShipping = $order->info['shipping_cost'] * $currencies->get_value($currency);

   		// The process_button_string contains the form that is sent to Hoopay.
   		$process_button_string = tep_draw_form('hoopay', 'https://www.hoopay.com/api/process.seam') .
      	tep_draw_hidden_field('member', MODULE_PAYMENT_HOOPAY_MERCHANTID) .
		tep_draw_hidden_field('action', 'payment') .
		tep_draw_hidden_field('price', number_format($hpOrderTotalV,2,'.','')) .
		tep_draw_hidden_field('currency', strtoupper($order->info['currency'])) .
		tep_draw_hidden_field('ureturn', tep_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL')) .
		tep_draw_hidden_field('ucancel', tep_href_link(FILENAME_DEFAULT, '', 'SSL')) .
		tep_draw_hidden_field('product', STORE_NAME) .
		tep_draw_hidden_field('quantity', '') .
		tep_draw_hidden_field('shipping', number_format($hpShipping,2,'.','')) .
		tep_draw_hidden_field('custom', $insert_id) .
		tep_draw_hidden_field('unotify', tep_href_link('hoopay_ipn.php', '', 'SSL'))
		.'<input type="submit" value="" disabled style="background-color:#FFFFFF; border:#FFFFFF;color:#FFFFFF"></form>
		<script>document.hoopay.submit();</script>'
		;
		echo $process_button_string;
		$cart->reset(true);
		tep_session_unregister('sendto');
	    tep_session_unregister('billto');
	    tep_session_unregister('shipping');
	    tep_session_unregister('payment');
	    tep_session_unregister('comments');
		exit;
    }

    function get_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_HOOPAY_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Hoopay Module', 'MODULE_PAYMENT_HOOPAY_STATUS', 'True', 'Do you want to accept Hoopay payments?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchants Email Address or Username', 'MODULE_PAYMENT_HOOPAY_MERCHANTID', '', 'Your Merchant Email Address or Username', '6', '1', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchants Signature', 'MODULE_PAYMENT_HOOPAY_MERCHANT_SIGNATURE', '', 'Your Merchant Signature', '6', '1', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_HOOPAY_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '10', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status for successed transaction', 'MODULE_PAYMENT_HOOPAY_ORDER_STATUS_ID_APPROVED', '0', 'Set the status of orders made after verifying the payment transaction', '6', '10', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_HOOPAY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '11', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_HOOPAY_STATUS', 'MODULE_PAYMENT_HOOPAY_MERCHANTID', 'MODULE_PAYMENT_HOOPAY_MERCHANT_SIGNATURE', 'MODULE_PAYMENT_HOOPAY_ORDER_STATUS_ID', 'MODULE_PAYMENT_HOOPAY_ORDER_STATUS_ID_APPROVED', 'MODULE_PAYMENT_HOOPAY_SORT_ORDER');
    }
  }
?>
